#include "fbmoc.h"

fbmoc::fbmoc()
{
}



void fbmoc::moc(QList<FBScanner::TOKEN> tokens)
{
    QFile out("fbm.bas");
    out.open(QFile::WriteOnly);

    bool at_start_of_line = true;
    bool inside_type = false;
    bool slots_dekl = false;

    QList<fb_type> typeList;
    fb_type type;

    for (int i = 0;i < tokens.count();i++)
    {
        if (at_start_of_line == true)
        {
            if (tokens[i].token == FBScanner::KEYWORD_TYPE)
            {
                inside_type = true;
                at_start_of_line = false;
                type.subs.clear();
                if (i+1 < tokens.count())
                {
                    type.name = tokens[i+1].value;
                    i++;
                }
                continue;
            }
        }

        if (inside_type == true)
        {
            if ((tokens[i].token == FBScanner::KEYWORD_PUBLIC || tokens[i].token == FBScanner::KEYWORD_PRIVATE) && i+1 < tokens.count())
            {
                if (tokens[i+1].token == FBScanner::KEYWORD_SLOTS)
                {
                    slots_dekl = true;
                } else
                {
                    slots_dekl = false;
                }

                continue;
            }

            
            
            
            if (slots_dekl == true)
            {
                if (tokens[i].token == FBScanner::KEYWORD_DECLARE && i+1 < tokens.count())
                {
                    fb_sub sub;

                    if (tokens[i+1].token == FBScanner::KEYWORD_SUB && i+2 < tokens.count())
                    {
                        sub.name = QString(tokens[i+2].value);
                        int brace = 0;
                        bool z = false;

                        for (int i2 = i+2;i2 < tokens.count();i2++)
                        {
                            if (tokens[i2].token == FBScanner::KEYWORD_ALIAS)
                            {
                                i++;
                            } else if (tokens[i2].token == FBScanner::KEYWORD_LIB)
                            {
                                i++;
                            } else if (tokens[i2].token == FBScanner::ENDOFSTATEMENT)
                            {
                                break;
                            } else if (tokens[i2].token == FBScanner::OPERATOR_ROUNDBRACKET_OPEN)
                            {
                                brace++;
                            } else if (tokens[i2].token == FBScanner::OPERATOR_ROUNDBRACKET_CLOSE)
                            {
                                brace--;
                            } else if (tokens[i2].token == FBScanner::OPERATOR_EQUAL)
                            {
                                z = true;
                            } else if (tokens[i2].token == FBScanner::OPERATOR_KOMMA && 1 == brace)
                            {
                                z = false;
                            } else if (tokens[i2].token == FBScanner::KEYWORD_AS && z == false && i2+1 < tokens.count())
                            {
                                fb_param param;
                                param.ptrs = 0;
                                param.type = tokens[i2+1].value;
                                for (int i3 = i2+1;i3 < tokens.count();i3++)
                                {
                                    if (tokens[i3].token == FBScanner::KEYWORD_PTR)
                                    {
                                        param.ptrs += 1;
                                    }

                                    if (tokens[i3].token == FBScanner::ENDOFSTATEMENT)
                                    {
                                        break;
                                    }
                                }
                                sub.params << param;
                                


                            }
                            
                        }

                        type.subs << sub;
                        sub.params.clear();

                    }

                    at_start_of_line = false;

                    continue;
                }
            }
        }


        if (tokens[i].token == FBScanner::KEYWORD_END && i+1 < tokens.count())
        {
            if (tokens[i+1].token == FBScanner::KEYWORD_TYPE)
            {
                inside_type = false;
                slots_dekl = false;
                i++;
                typeList << type;
            }
        }




        if (tokens[i].token == FBScanner::ENDOFSTATEMENT)
        {
            at_start_of_line = true;
        } else
        {
            at_start_of_line = false;
        }

    }






    out.write("#inclib \"QtGui4\"\n#inclib \"QtCore4\"\nextern import QObjectStaticMetaObject(16) alias \"_ZN7QObject16staticMetaObjectE\" as byte\ntype _QMetaObject\nmooqo as byte ptr\nmeta_string as zstring ptr\nmeta_data as uinteger ptr\ni as integer\nend type\n\n\n");
    for (int i = 0;i < typeList.count();i++)
    {
        QString name = typeList[i].name;
        int slots_count = typeList[i].subs.count();
        QString _slots;
        QString slotdata;
        int paramIndex = name.length() + 1;
        int slotCount = 0;
        int len_slots = 0;

        _slots = "\"" + name + "\"+ chr(0) + chr(0) + \"";
        len_slots = name.count()+2;

        for (int i2 = 0;i2 < typeList[i].subs.count();i2++)
        {
            slotdata.append(QString::number(QString(_slots).remove(" ").remove("\"").remove("+").replace("chr(0)","0").length())).append(",").append(QString::number(paramIndex)).append(",").append(QString::number(paramIndex)).append(",").append(QString::number(paramIndex)).append(",&H0a, _\n");
            slotCount++;
            _slots += typeList[i].subs[i2].name;
            _slots += "(";
            for (int i3 = 0;i3 < typeList[i].subs[i2].params.count();i3++)
            {
                QString p;
                p = cNameOfDatatype(typeList[i].subs[i2].params[i3]);
                _slots += p;
                _slots += ",";

                len_slots += p.count();
                len_slots += 1;
            }
            _slots.remove(-1,1);
            _slots += ")\" + chr(0) + \"";

            len_slots += 3;
        }

        _slots.remove(-3,3);

        QString staticmeta = QString("4, 0,0,0,").append(QString::number(slots_count)).append(",14,0,0,0,0,0,0,0,0, _ \n").append(slotdata).append("0");
        QString code;
        code = QString("dim shared as zstring ptr qt_meta_string_").append(name)/*.append(" = allocate(").append(QString::number(len_slots))*/.append("\n");
        code.append("*qt_meta_string_").append(name).append(" = ").append(_slots).append("\n");
        code.append("dim shared as uinteger qt_meta_data_object_").append(name).append("(").append(QString::number(15+5*slots_count)).append(") = { _ \n").append(staticmeta.toAscii()).append("}\n\n\n");
        code.append("dim shared staticMeta_").append(name).append("(16) as byte\n");
        code.append("function _metaobject_").append(name).append(" cdecl (byval p as any ptr) as any ptr\nreturn @staticMeta_").append(name).append("(0)\nend function\n\n\n");
        code.append("function _metacall_").append(name).append(" cdecl (byval p as any ptr, byval op as integer, byval index as integer, byval args as integer ptr ptr) as integer\nprint \"Slot!\"\nend function\n");


        out.write(code.toAscii());
    }


    QString code = "\n\n\nsub InitSignalSlot()\n";
    for (int i = 0;i < typeList.count();i++)
    {
        QString name = typeList[i].name;

        code.append("poke integer,@staticMeta_").append(name).append("(0),@QObjectStaticMetaObject(0)\n");
        code.append("poke integer,@staticMeta_").append(name).append("(4),qt_meta_string_").append(name).append("\n");
        code.append("poke integer,@staticMeta_").append(name).append("(8),@qt_meta_data_Object_").append(name).append("(0)\n");
        code.append("poke integer,@staticMeta_").append(name).append("(12),0\n");
    }
    out.write(code.append("end sub\n").toAscii());
    out.close();
}

















QString fbmoc::cNameOfDatatype(fb_param fbname)
{
    QString ret;
    if (fbname.type == "integer")
    {
        ret = "int";
    } else if (fbname.type == "byte")
    {
        ret = "char";
    } else if (fbname.type == "short")
    {
        ret = "short";
    } else if (fbname.type == "single")
    {
        ret = "float";
    } else if (fbname.type == "double")
    {
        ret = "double";
    } else if (fbname.type == "zstring")
    {
        ret = "char";
    } else if (fbname.type == "string")
    {
        ret = "char";
    } else
    {
        ret = fbname.type;
    }


    for (int i = 0;i < fbname.ptrs;i++)
    {
        ret += "*";
    }

    return ret;
}
