#ifndef FBSCANNER_H
#define FBSCANNER_H

#include <QtCore>

class FBScanner
{
public:

    enum TOKEN_ENUM
    {
        ENDOFFILE,
        ENDOFSTATEMENT,
        ENDOFLINE,
        OPERATOR_PLUS,
        OPERATOR_MINUS,
        OPERATOR_ASTERISK,
        OPERATOR_SLASH,
        OPERATOR_BACKSLASH,
        OPERATOR_EQUAL,
        OPERATOR_LESSTHAN,
        OPERATOR_GREATERTHEN,
        OPERATOR_EXP,
        OPERATOR_DOT,
        OPERATOR_ROUNDBRACKET_OPEN,
        OPERATOR_ROUNDBRACKET_CLOSE,
        OPERATOR_SQUAREBRACKET_OPEN,
        OPERATOR_SQUAREBRACKET_CLOSE,
        OPERATOR_CURLYBRACKET_OPEN,
        OPERATOR_CURLYBRACKET_CLOSE,
        OPERATOR_AT,
        OPERATOR_AMPERSAND,
        OPERATOR_UNDERSCORE,
        OPERATOR_QUESTIONMARK,
        OPERATOR_HASH,
        OPERATOR_ARROW,
        OPERATOR_KOMMA,

        NUMBER,
        STRING,
        COMMENT_SINGLE,
        COMMENT_MULTI,

        KEYWORD_DECLARE,
        KEYWORD_SUB,
        KEYWORD_FUNCTION,
        KEYWORD_LIB,
        KEYWORD_ALIAS,
        KEYWORD_BYVAL,
        KEYWORD_BYREF,
        KEYWORD_TYPE,
        KEYWORD_END,
        KEYWORD_PRIVATE,
        KEYWORD_PUBLIC,
        KEYWORD_SLOTS,
        KEYWORD_AS,
        KEYWORD_PTR,

        IDENTIFIER,
        INVALID
    };


    enum SCANNER_MODE
    {
        MODE_NORMAL,
        MODE_STRING,
        MODE_COMMENT,
        MODE_NUMBER
    };

    struct TOKEN
    {
        TOKEN_ENUM token;
        QString value;
    };


    FBScanner();

    QList<TOKEN> scan(QString code);
    TOKEN_ENUM tokenize(QString &symbol);

    QStringList operatorList;
    QStringList separatorList;

};

#endif // FBSCANNER_H
