#include <QtCore>
#include "fbscanner.h"
#include "fbmoc.h"

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);

    if (argc < 2)
    {
        printf("ERROR 1: wrong number of parameters");
        return 1;
    }
    FBScanner scanner;
    QFile file(argv[1]);

    file.open(QFile::ReadOnly);
    QString code = file.readAll();
    QList<FBScanner::TOKEN> list = scanner.scan(code);

    fbmoc moc;
    moc.moc(list);

    QFile log("log.txt");
    log.open(QFile::WriteOnly);

    for (int i = 0;i < list.count();i++)
    {
        log.write(list[i].value.append("\n").toAscii());
    }

    log.close();

}
